"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@theia/core");
var inversify_1 = require("inversify");
var protocol_1 = require("../common/protocol");
var open_editor_service_1 = require("./open-editor-service");
var open_editor_express_service_1 = require("./open-editor-express-service");
var backend_application_1 = require("@theia/core/lib/node/backend-application");
exports.default = new inversify_1.ContainerModule(function (bind) {
    bind(open_editor_express_service_1.EditorOpenExpressService)
        .toSelf()
        .inSingletonScope();
    bind(backend_application_1.BackendApplicationContribution).toService(open_editor_express_service_1.EditorOpenExpressService);
    bind(protocol_1.OpenEditorBackendService)
        .to(open_editor_service_1.OpenEditorBackendServiceClientImpl)
        .inSingletonScope();
    bind(core_1.ConnectionHandler)
        .toDynamicValue(function (ctx) {
        return new core_1.JsonRpcConnectionHandler(protocol_1.OPEN_EDITOR_BACKEND_PATH, function (client) {
            var server = ctx.container.get(protocol_1.OpenEditorBackendService);
            server.setClient(client);
            return server;
        });
    })
        .inSingletonScope();
});
//# sourceMappingURL=open-editor-backend-module.js.map