"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditorOpenExpressService = void 0;
var inversify_1 = require("inversify");
var core_1 = require("@theia/core");
var protocol_1 = require("../common/protocol");
var EditorOpenExpressService = /** @class */ (function () {
    function EditorOpenExpressService() {
    }
    EditorOpenExpressService.prototype.configure = function (app) {
        var _this = this;
        app.post("/api/openEditor/:method", function (req, res) { return __awaiter(_this, void 0, void 0, function () {
            var token, filePath, _a, _b, e_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        token = process.env["THEIA_OPEN_EDITOR_TOKEN"];
                        if (token === undefined) {
                            this.logger.error("THEIA_OPEN_EDITOR_TOKEN is missing in process environment.");
                            return [2 /*return*/, res.status(500).send("Server Error")];
                        }
                        if (req.header("X-Authentication-Token") !== token) {
                            return [2 /*return*/, res.status(403).send("Unauthorized")];
                        }
                        filePath = req.body["filePath"];
                        if (!(typeof filePath === "string" && filePath)) {
                            return [2 /*return*/, res.status(400).send("Missing request parameter: filePath")];
                        }
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 8, , 9]);
                        if (!(req.params["method"] === "openFile")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.service.openFile(filePath)];
                    case 2:
                        _c.sent();
                        return [2 /*return*/, res.status(200).send("OK")];
                    case 3:
                        if (!(req.params["method"] === "closeFile")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.service.closeFile(filePath)];
                    case 4:
                        _c.sent();
                        return [2 /*return*/, res.status(200).send("OK")];
                    case 5:
                        if (!(req.params["method"] === "isFileOpen")) return [3 /*break*/, 7];
                        _b = (_a = res.status(200)).json;
                        return [4 /*yield*/, this.service.isFileOpen(filePath)];
                    case 6: return [2 /*return*/, _b.apply(_a, [_c.sent()])];
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        e_1 = _c.sent();
                        return [2 /*return*/, res.status(500).send(e_1)];
                    case 9: return [2 /*return*/];
                }
            });
        }); });
    };
    __decorate([
        inversify_1.inject(core_1.ILogger),
        __metadata("design:type", Object)
    ], EditorOpenExpressService.prototype, "logger", void 0);
    __decorate([
        inversify_1.inject(protocol_1.OpenEditorBackendService),
        __metadata("design:type", Object)
    ], EditorOpenExpressService.prototype, "service", void 0);
    EditorOpenExpressService = __decorate([
        inversify_1.injectable()
    ], EditorOpenExpressService);
    return EditorOpenExpressService;
}());
exports.EditorOpenExpressService = EditorOpenExpressService;
//# sourceMappingURL=open-editor-express-service.js.map